import os
import subprocess
import psutil
import winreg


def set_process_priority(process_name, priority=psutil.HIGH_PRIORITY_CLASS):
    for proc in psutil.process_iter():
        try:
            if process_name.lower() in proc.name().lower():
                proc.nice(priority)
                print(f"Priorité du processus {proc.name()} réglée sur haute.")
        except (psutil.NoSuchProcess, psutil.AccessDenied, psutil.ZombieProcess):
            pass

def optimize_graphics_settings():
    gta_settings_path = os.path.join(os.getenv('USERPROFILE'), 'Documents', 'Rockstar Games', 'GTA V', 'settings.xml')
    if os.path.exists(gta_settings_path):
        try:
            with open(gta_settings_path, 'r+') as file:
                content = file.read()
                content = content.replace('<DX_Version value="2"/>', '<DX_Version value="1"/>') 
                content = content.replace('<ShadowQuality value="2"/>', '<ShadowQuality value="0"/>')
                content = content.replace('<TextureQuality value="2"/>', '<TextureQuality value="0"/>')
                file.seek(0)
                file.write(content)
                file.truncate()
            print("Les paramètres graphiques de GTA V ont été optimisés.")
        except Exception as e:
            print(f"Erreur lors de la modification des paramètres graphiques : {e}")
    else:
        print("Impossible de localiser le fichier settings.xml pour GTA V.")

def free_memory():
    try:
        subprocess.run("EmptyStandbyList.exe workingsets", shell=True)
        subprocess.run("EmptyStandbyList.exe standbylist", shell=True)
        print("Mémoire libérée avec succès.")
    except Exception as e:
        print(f"Erreur lors du nettoyage de la mémoire : {e}")

def disable_unnecessary_services():
    services_to_disable = [
        'SysMain',
        'DiagTrack',
        'WSearch'
    ]
    for service in services_to_disable:
        try:
            subprocess.run(f"sc stop {service}", shell=True)
            subprocess.run(f"sc config {service} start= disabled", shell=True)
            print(f"Service {service} désactivé.")
        except Exception as e:
            print(f"Erreur lors de la désactivation du service {service} : {e}")

def optimize_virtual_memory():
    try:
        subprocess.run("wmic computersystem where name=\"%computername%\" set AutomaticManagedPagefile=False", shell=True)
        subprocess.run("wmic pagefileset where name=\"C:\\\\pagefile.sys\" set InitialSize=4096,MaximumSize=8192", shell=True)
        print("Mémoire virtuelle optimisée.")
    except Exception as e:
        print(f"Erreur lors de l'optimisation de la mémoire virtuelle : {e}")

def set_gta_fivem_priority():
    set_process_priority("GTA5.exe", psutil.HIGH_PRIORITY_CLASS)
    set_process_priority("FiveM_GTAProcess.exe", psutil.HIGH_PRIORITY_CLASS)

def disable_game_dvr():
    try:
        key = winreg.OpenKey(winreg.HKEY_CURRENT_USER, r"SOFTWARE\Microsoft\Windows\CurrentVersion\GameDVR", 0, winreg.KEY_ALL_ACCESS)
        winreg.SetValueEx(key, "AppCaptureEnabled", 0, winreg.REG_DWORD, 0)
        winreg.SetValueEx(key, "GameDVR_Enabled", 0, winreg.REG_DWORD, 0)
        winreg.CloseKey(key)
        print("Game DVR désactivé.")
    except Exception as e:
        print(f"Erreur lors de la désactivation de Game DVR : {e}")

def optimize_gta_fivem():
    print("Optimisation de GTA V et FiveM pour gagner des FPS...")
    
    optimize_graphics_settings()
    
    optimize_virtual_memory()
    
    disable_unnecessary_services()
    
    free_memory()
    
    set_gta_fivem_priority()
    
    disable_game_dvr()

    print("Optimisation complète terminée pour GTA V et FiveM.")

if __name__ == "__main__":
    optimize_gta_fivem()
