@echo off
SETLOCAL

python --version >nul 2>&1
IF %ERRORLEVEL% NEQ 0 (
    echo Python n'est pas installé. Téléchargement de Python...
    curl -o python-installer.exe https://www.python.org/ftp/python/3.10.7/python-3.10.7-amd64.exe

    echo Installation de Python...
    python-installer.exe /quiet InstallAllUsers=1 PrependPath=1 Include_test=0

    del python-installer.exe

    echo Python a été installé avec succès.
) ELSE (
    echo Python est déjà installé.
)

pip --version >nul 2>&1
IF %ERRORLEVEL% NEQ 0 (
    echo pip n'est pas installé. Installation de pip...
    python -m ensurepip --upgrade
    python -m pip install --upgrade pip setuptools wheel
    echo pip a été installé avec succès.
) ELSE (
    echo pip est déjà installé.
)

echo Installation des requirements...
pip install psutil

IF NOT EXIST "EmptyStandbyList.exe" (
    echo Téléchargement de EmptyStandbyList.exe...
    curl -o EmptyStandbyList.exe https://wj32.org/wp-content/uploads/2018/10/empty-standby-list.zip
    echo Extraction de EmptyStandbyList.exe...
    tar -xf empty-standby-list.zip
    del empty-standby-list.zip
)

echo Exécution du script d'optimisation...
python optimize_gta_fivem.py

echo Tout est terminé ! Appuyez sur une touche pour fermer cette fenêtre.
pause
ENDLOCAL
